<template>
    <div class="text-end px-2">
        <button alt="Guardar" title="Guardar" v-show="data.tipo_transf != null" type="button"
            class="btn btn-guardar mt-1 mx-2 fs-3" @click="guardar()">
            <i class="fa-solid fa-floppy-disk "></i>
        </button>
    </div>

    <h5 class="mt-4 ps-3"> SOLICITANTE: <b> {{ data.solicitante?.ayn }} </b></h5>

    <div class=" d-md-flex align-items-center flex-wrap justify-content-start p-4 contenedorPrincipal m-3">
        <div class="col-3 ms-3">
            <label class="form-label">Tipo de transferencia:</label>
            <select v-model="data.tipo_transf" class="w-100 d-block" id="tipo_transf">
                <option :value="null" v-text="'--Seleccione--'"></option>
                <option v-for="TipoTransf in transferenciaStore.listadoTiposTransf" :key="TipoTransf.key"
                    :value="TipoTransf.key" v-text="TipoTransf.d_tipo_transf">
                </option>
            </select>
        </div>
        <div class="col-2 ms-3">
            <label class="form-label">Fecha:</label>
            <input readonly type="date" v-model="data.fecha_hoy" class="d-bloc w-100" id="f_hoy" autocomplete="off" />
        </div>
        <div class="col-3 ms-3 ">
            <label class="form-label">Importe Total:</label>
            <InputCurrency readonly class="form-control" v-model="totalTransferencia" :disabled="false" />
        </div>
        <div class="col-4 ms-3 mt-3">
            <label class="form-label">Observaciones:</label>
            <textarea placeholder="Escriba una observacion" type="text" v-model="data.observaciones" class="form-control"
                id="observ"> </textarea>
        </div>
        <div class="col-4 ms-3 mt-3">
            <label v-show="enableComponent" class="form-label me-2">Importe Transferido desde Subsidios:</label>
            <InputCurrency v-show="enableComponent" readonly class="form-control" v-model="data.total" :disabled="false" />
        </div>
    </div>
    <table class="table table-striped mt-4" v-if="cuposStore.cupos.length > 0">
        <thead>
            <tr>
                <th scope="col">Fecha</th>
                <th scope="col">Monto Otorgado</th>
                <th scope="col">Monto Gastado</th>
                <th scope="col">Monto Disponible</th>
                <th scope="col">Transfiere</th>
            </tr>
        </thead>
        <tbody>
            <tr v-for="transf in transferencias">
                <td v-text="formatDate(transf.fecha_cupo)"></td>
                <td v-text="'$' + formatPrice(transf.monto_otorgado)"></td>
                <td v-text="'$' + formatPrice(transf.monto_gastado)"></td>
                <td v-text="'$' + formatPrice(transf.monto_disponible)"></td>
                <td>
                    <InputCurrency v-if="data.tipo_transf !== 'O' && data.tipo_transf !== 'T'" class="form-control mb-2"
                        :class="{ 'bg-danger': !transf.valido }" v-model="transf.transfiere" :disabled="false" />
                    <InputCurrency v-if="data.tipo_transf == 'O' || data.tipo_transf == 'T'" class="form-control mb-2"
                        :class="{ 'bg-danger': !transf.valido }" v-model="transf.transfiere" :disabled="false"
                        :options="configInputCurrency" />
                </td>
            </tr>
        </tbody>
    </table>
    <div v-else class="alert alert-secondary" role="alert">
        No hay elementos para mostrar
    </div>
</template>

<script setup lang="ts">
//librerias
import { reactive, computed, onMounted, watch, ref, type Ref } from "vue";
import { useRoute, useRouter } from "vue-router";
import http from "@/http";
import { loading, urlApi } from "@/shared.js";
import Swal from "sweetalert2/dist/sweetalert2.js";
import type { CurrencyInputOptions, NumberRange } from "vue-currency-input";
import { InputCurrency } from "@hcd-bsas/vue3-components";
import { DateTime } from "luxon";
//Entities
import type Tipotransf from "@/entities/transferencias/TipoTransf";
import Solicitante from "@/entities/Solicitante";
// Stores
import { useConfigStore } from "@/stores/configgral";
import { useTransferenciasStore } from "@/stores/transferencias/transferencias";
import { useUsuariosStore } from "@/stores/usuarios";
import { useCuposStore } from "@/stores/becas/cupos";//este es el de facu no el mio
import type Cupo from "@/entities/becas/Cupo";

const transferenciaStore = useTransferenciasStore();
const configStore = useConfigStore();
const cuposStore = useCuposStore();
const usuarioStore = useUsuariosStore();

const router = useRouter();
const route = useRoute();

var data = reactive({
    solicitante: undefined as Solicitante | undefined,
    tipo_transf: null as Tipotransf | null,
    fecha_hoy: "" as string | null,
    observaciones: "" as string,
    total: 0 as number,
    id_transferencia: null as number | null,
});

var fechas = reactive({
    anioActivo: "",
    f_cupo_des: "",
    f_cupo_has: ""
});

var configInputCurrency = reactive({
    valueRange: {
        min: -9999999999 as number | undefined,
    } as NumberRange
} as CurrencyInputOptions);

const enableComponent = computed(() => {
    if (data.tipo_transf !== 'B') {
        return false;
    } else { return true; }
});

var transferencias: Ref<Cupo[]> = ref([]);

onMounted(async () => {
    loading.show();
    var periodo = route.params.periodo;
    var id_tabla_sol = route.params.id_tabla_sol;
    await configStore.updateListadoPeriodo();
    fechas.anioActivo = configStore.listadoPeriodoActivo[0]?.anioActivo;
    fechas.f_cupo_des = periodo + '-03-01';
    fechas.f_cupo_has = fechas.anioActivo + '-12-31';
    await Promise.all([
        transferenciaStore.updateListadoTransferencias({
            listar_sin_cupo_por_cargo: '1'
        }),
        cuposStore.fetchCupos({
            f_cupo_des: fechas.f_cupo_des,
            f_cupo_has: fechas.f_cupo_has,
            id_tabla_sol: id_tabla_sol,
        }),
    ]);
    transferencias.value = cuposStore.getCupos();
    var now = DateTime.now().toFormat('yyyy-LL-dd');
    data.fecha_hoy = now;
    data.solicitante = await usuarioStore.findSolicitanteById(parseInt(id_tabla_sol));
    loading.hide();
});

const totalTransferencia = computed(() => {
    let total = 0;
    transferencias.value.forEach(element => {
        element.valido = true;
        if (data.tipo_transf == 'S') {
            if (element.transfiere > element.monto_disponible) {
                element.valido = false;
                console.log("NO TIENE SALDO DISPONIBLE");
            } else {
                total += element.transfiere;
            }
        } else {
            if (data.tipo_transf == 'O' || data.tipo_transf == 'T') {
                if (Math.abs(element.transfiere) > element.monto_disponible) {
                    element.valido = false;
                    console.log("NO TIENE SALDO DISPONIBLE");
                } else {
                    total += Math.abs(element.transfiere);
                }
            }
            else {
                total += element.transfiere;
            }
        }
    });
    return total;
});

watch(() => data.tipo_transf, async (newValue: any, oldValue: any) => {
    if (newValue == 'B') {
        var rta = await http.post(urlApi + "getTransferenciasdeSubsidiosImporte", {
            id_tabla_sol: data.solicitante?.id_tabla_sol,
        });
        if (rta.data.length > 0) {
            data.total = parseInt(rta.data[0].importe);
            data.id_transferencia = rta.data[0].id_transferencia;
        } else {
            data.total = 0;
        }
    } else {
        data.total = 0;
    }
});

function formatDate(date: string | null) {
    if (date != null) {
        return DateTime.fromISO(date).toLocaleString();
    }
}

function formatPrice(value: any) {
    let val = (value / 1).toFixed(2).replace('.', ',')
    return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".")
}

async function guardar() {
    var array_periodo_monto = "";
    try {
        transferencias.value.forEach((element) => {
            if (element.transfiere > 0) {
                if (data.tipo_transf == 'S') {
                    if (data.tipo_transf == 'S' && element.transfiere > element.monto_disponible) {
                        array_periodo_monto = "";
                        throw { message: "El monto a transferir para la fecha " + formatDate(element.fecha_cupo) + " supera el monto disponible." };
                    }
                    array_periodo_monto += element.fecha_cupo + ";" + element.transfiere + "|";
                }
            }
            if (data.tipo_transf == 'B') {
                if (totalTransferencia.value > data.total) {
                    array_periodo_monto = "";
                    throw { message: "El Importe Total supera el Importe Transferido desde Subsidios disponible." };

                }
                if (totalTransferencia.value < data.total) {
                    array_periodo_monto = "";
                    throw { message: "El Importe Total es menor al Importe Transferido desde Subsidios disponible." };

                }
                array_periodo_monto += element.fecha_cupo + ";" + element.transfiere + "|";
            }
            if (data.tipo_transf == 'O' || data.tipo_transf == 'T') {
                if (element.transfiere !== 0) {
                    if (totalTransferencia.value > element.monto_disponible) {
                        array_periodo_monto = "";
                        throw { message: "El Importe Total es mayor al Importe disponible." };
                    }
                    array_periodo_monto += element.fecha_cupo + ";" + element.transfiere + "|";
                }
            }
        });
    } catch (error: any) {
        Swal.fire({
            icon: "error",
            text: error.message,
        });
    }
    if (array_periodo_monto == "") {
        return false;
    }
    await http.post(urlApi + "addCupoSolicitanteGrabar", {
        tipo_transf: data.tipo_transf,
        accion: "A",
        f_periodo: fechas.anioActivo,
        id_tabla_sol: data.solicitante?.id_tabla_sol,
        monto: totalTransferencia.value,
        f_desde: fechas.f_cupo_des,
        f_hasta: fechas.f_cupo_has,
        array_periodo_monto: array_periodo_monto,
        observaciones: data.observaciones,
        id_transferencia: data.id_transferencia,
    }).then(async () => {
        router.push({
            name: "inicioTransferencias",
            params: { id_tabla_sol: data.solicitante?.id_tabla_sol },
        });
        Swal.fire({
            icon: "success",
            text: "Se grabo la Transferencia.",
        })
        loading.hide();
    }).catch(function (error) {
        console.log(error);
        Swal.fire({
            icon: "error",
            text: error.response.data.message.replace("Error al ejecutar la operación solicitada en la base de datos. Por favor, avise al Administrador. Mensaje de la excepción de Microsoft SQL Server:", ""),
        });
        loading.hide();
    });
}
</script>
